# encoding: UTF-8
#{ ---------------------------------------------------------------------------
#
#  SketchUp Extension Registrar Script for:
#  Number Component
#  Adds 3D Text to place sequential numbers on each component or group selected. 
#  Attempts to number them in a grid from left to right and top to bottom.
#
#  ---------------------------------------------------------------------------
#
#{ COPYRIGHT:
#
#  © 2018 Gordon McIntyre
#
#} ---------------------------------------------------------------------------
#
#{ LICENSE:
#
#  All rights reserved.
#
#} ---------------------------------------------------------------------------
#
#{ WARRANTY:
#
#  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
#  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
#  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
#} ---------------------------------------------------------------------------

#{# DEPENDANCIES:
#
  require('sketchup.rb')
  require('extensions.rb')
#  require('langhandler.rb')
#
#}
#}

module GM
  module NumberComponent
  #{# FILE & PATH CONSTANTS
      FOLDER = Module::nesting[0].name.gsub(/(::)/,'_')

      # Plugin files prefixed by inner module name:
      SELFNAME = self.name.split("::")[1]
      LOADER = "#{SELFNAME}_loader"

      REL_PATH = File.join( FOLDER, LOADER )
      ABS_PATH = File.join( File.dirname(__FILE__), REL_PATH )
  #}#

  #{# CONSTANTS FOR EXTENSION PANEL OF PREFERENCES DIALOG
  #
    VERSION = '1.0.0'
    AUTHOR  = 'Gordon McIntyre'
    YEAR    = '2018'
    LEGAL = 'All Rights Reserved'

    if YEAR.empty?
      COPYRIGHT = "#{LEGAL}"
    elsif YEAR =~ /\A\D/
      COPYRIGHT = "#{YEAR}, #{LEGAL}"
    else
      COPYRIGHT = "©#{YEAR}, #{LEGAL}"
    end

    CAPTION = 'Number Component'
  #
  #}#

  #{# DEFINE THE EXTENSION:
  #
    unless defined?(@@extension)
      @@extension = SketchupExtension.new( CAPTION, REL_PATH )
      @@extension.description = "Number Component Adds 3D Text to place sequential numbers" + 
      " on each component or group selected."
      @@extension.version = "#{VERSION}"
      @@extension.creator = "#{AUTHOR}"
      @@extension.copyright = "#{COPYRIGHT}"
      # REGISTER THE EXTENSION WITH SKETCHUP:
      Sketchup.register_extension( @@extension, true )
    end #unless defined?
    #
  #}#

  #{# DEFINE AN EXTENSION REFERENCE GETTER METHOD:
  #
      def extension()
      # Returns a reference to the extension instance.
        @@extension
      end
      module_function(:extension)
  #
  #}#

  end #module NumberComponent
end #module GB